module.exports = {
    Error: function (a, b) {
        try {
            a = 'undefined' == typeof a ? '0' : a, b = 'undefined' == typeof b ? 'Null,Null' : b;
            var c = b.split('<>');
            switch (a) {
                case 'a0xj0s1':
                    return {
                        resume: !0,
                        code: 'MIRA',
                        text: 'null'
                    };
                    break;
                case 'a0xj001':
                    return {
                        resume: !0,
                        code: 'MIRA_2001',
                        text: J_string('connection was successful %s', [c[0]])
                    };
                    break;
                case 'a0xj002':
                    return {
                        resume: !1,
                        code: 'MIRA_2002',
                        text: J_string('server startup failed %s', [c[0]])
                    };
                    break;
                case 'w0xj001':
                    return {
                        resume: !1,
                        code: 'MIRA_3001',
                        text: J_string('access denied for (%s) user to (%s) database', [c[0], c[1]])
                    };
                    break;
                case 'e0xj001':
                    return {
                        resume: !1,
                        code: 'MIRA_3002',
                        text: J_string('access denied (%s)', [c[0]])
                    };
                    break;
                case 'e0xj002':
                    return {
                        resume: !1,
                        code: 'MIRA_2003',
                        text: J_string('your client version rejected by the server %s', [c[0]])
                    };
                    break;
                case 'e0xje01':
                    return {
                        resume: !1,
                        code: 'MIRA_1001',
                        text: J_string('you have an error in your MIRA syntax %s', [c[0]])
                    };
                    break;
                case 'e0xje02':
                    return {
                        resume: !1,
                        code: 'MIRA_1002',
                        text: J_string('unknow query error -> (%s)', [c[0]])
                    };
                    break;
                case 'e0xje03':
                    return {
                        resume: !1,
                        code: 'MIRA_1003',
                        text: J_string('you have an error in your (UPDATE query) %s', [c[0]])
                    };
                    break;
                case 'e0xje04':
                    return {
                        resume: !1,
                        code: 'MIRA_1004',
                        text: J_string('you have an error in your (SELECT query) %s', [ErrorMessages(c[0], 'table or column')])
                    };
                    break;
                case 'e0xje05':
                    return {
                        resume: !1,
                        code: 'MIRA_3003',
                        text: J_string('database file is damaged %s', [c[0]])
                    };
                    break;
                case 'e0xje06':
                    return {
                        resume: !1,
                        code: 'MIRA_3004',
                        text: J_string('cannot read table (%s) from database', [c[0]])
                    };
                    break;
                case 'e0xje07':
                    return {
                        resume: !1,
                        code: 'MIRA_3005',
                        text: J_string('cannot read column (%s) to (%s) from table', [c[0], c[1]])
                    };
                    break;
                case 'e0xje08':
                    return {
                        resume: !1,
                        code: 'MIRA_1005',
                        text: J_string('you have an error in your (INSERT query) %s', [ErrorMessages(c[0], 'table or column')])
                    };
                    break;
                case 'e0xje09':
                    return {
                        resume: !1,
                        code: 'MIRA_1006',
                        text: J_string('you have an error in your (CREATE query) %s', [c[0]])
                    };
                    break;
                case 'e0xje10':
                    return {
                        resume: !1,
                        code: 'MIRA_1007',
                        text: J_string('cannot create database (%s) illegal or ambiguous name -> permitted only [0-9,a-z,A-Z_]', [c[0]])
                    };
                    break;
                case 'e0xje11':
                    return {
                        resume: !1,
                        code: 'MIRA_1008',
                        text: J_string('cannot create table (%s) illegal or ambiguous name -> permitted only [0-9,a-z,A-Z_]', [c[0]])
                    };
                    break;
                case 'e0xje12':
                    return {
                        resume: !1,
                        code: 'MIRA_2004',
                        text: J_string('cannot open database (%s) damaged or unreadable', [c[0]])
                    };
                    break;
                case 'e0xje213':
                    return {
                        resume: !1,
                        code: 'MIRA_2005',
                        text: J_string('database file is damaged or not exist (%s)', [c[0]])
                    };
                    break;
                case 'e0xje13':
                    return {
                        resume: !1,
                        code: 'MIRA_2005',
                        text: J_string('database folder does not exist (%s)', [c[0]])
                    };
                    break;
                case 'e0xje14':
                    return {
                        resume: !1,
                        code: 'MIRA_3006',
                        text: J_string('permission denied type:(\'%s\')', [c[0]])
                    };
                    break;
                case 'e0xje16':
                    return {
                        resume: !1,
                        code: 'MIRA_1009',
                        text: J_string('you have an error in your (%s query)', [c[0]])
                    };
                    break;
                case 'e0xje17':
                    return {
                        resume: !1,
                        code: 'MIRA_3008',
                        text: J_string('empty database (name) in connection string %s', [c[0]])
                    };
                    break;
                case 'e0xjl01':
                    return {
                        resume: !1,
                        code: 'MIRA_2006',
                        text: J_string('could not open configuration file! -> \'%s\'', [c[0]])
                    };
                    break;
                case 'e0xjl02':
                    return {
                        resume: !1,
                        code: 'MIRA_3011',
                        text: J_string('username or password not recognized %s', [c[0]])
                    };
                    break;
                case 'e0xjl03':
                    return {
                        resume: !1,
                        code: 'MIRA_2007',
                        text: J_string('cannot open database! \'%s\'', [c[0]])
                    };
                    break;
                case 'e0xjl04':
                    return {
                        resume: !1,
                        code: 'MIRA_2008',
                        text: J_string('cannot open policy file %s', [c[0]])
                    };
                    break;
                case 'e0xjl05':
                    return {
                        resume: !1,
                        code: 'MIRA_2009',
                        text: J_string('unknow file error -> \'%s\'', [c[0]])
                    };
                    break;
                case 'e0xj0s1':
                    return {
                        resume: !1,
                        code: 'MIRA_2010',
                        text: J_string('server header error %s', [c[0]])
                    };
                    break;
                case 'e0xj0s2':
                    return {
                        resume: !1,
                        code: 'MIRA_3012',
                        text: J_string('(client\'s) send function error %s', [c[0]])
                    };
                    break;
                case 'e0xj0s3':
                    return {
                        resume: !1,
                        code: 'MIRA_3013',
                        text: J_string('send function error %s', [c[0]])
                    };
                    break;
                case 'e0xj0s4':
                    return {
                        resume: !1,
                        code: 'MIRA_3014',
                        text: J_string('authentication function error %s', [c[0]])
                    };
                    break;
                case 'e0xj0s5':
                    return {
                        resume: !1,
                        code: 'MIRA_3015',
                        text: J_string('client disconnect function error %s', [c[0]])
                    };
                    break;
                case 'e0xj0s6':
                    return {
                        resume: !1,
                        code: 'MIRA_3016',
                        text: J_string('client connect function error %s', [c[0]])
                    };
                    break;
                case 'w0xj0s1':
                    return {
                        resume: !1,
                        code: 'MIRA_3017',
                        text: J_string('Disconnected \'%s\'', [c[0]])
                    };
                    break;
                case 'w0xj0s2':
                    return {
                        resume: !1,
                        code: 'MIRA_3018',
                        text: J_string('Connected \'%s\'', [c[0]])
                    };
                    break;
                case 'w0xj0s3':
                    return {
                        resume: !1,
                        code: 'MIRA_3018',
                        text: J_string('Accept Waiting \'%s\'', [c[0]])
                    };
                    break;
                case 'w0xjs03':
                    return {
                        resume: !1,
                        code: 'MIRA_1010',
                        text: J_string('database (%s) already exists!', [c[0]])
                    };
                    break;
                case 'w0xjs04':
                    return {
                        resume: !1,
                        code: 'MIRA_1011',
                        text: J_string('cannot remove database \'%s\' file system error!', [c[0]])
                    };
                    break;
                case 'w0xjs05':
                    return {
                        resume: !1,
                        code: 'MIRA_1012',
                        text: J_string('cannot remove table \'%s\'!', [c[0]])
                    };
                    break;
                case 'w0xjs06':
                    return {
                        resume: !1,
                        code: 'MIRA_1013',
                        text: J_string('table (%s) already exists!', [c[0]])
                    };
                    break;
                case 'w0xjs07':
                    return {
                        resume: !1,
                        code: 'MIRA_1014',
                        text: J_string('cannot open table (%s) damaged or unreadable!', [c[0]])
                    };
                    break;
                case 'e0xj0s7':
                    return {
                        resume: !1,
                        code: 'MIRA_3019',
                        text: J_string('mod function error %s', [c[0]])
                    };
                    break;
                case 'e0xj0s8':
                    return {
                        resume: !1,
                        code: 'MIRA_3020',
                        text: J_string('filesystem function error %s', [c[0]])
                    };
                    break;
                case 'e0xj0s9':
                    return {
                        resume: !1,
                        code: 'MIRA_1015',
                        text: J_string('remove database function error %s', [c[0]])
                    };
                    break;
                case 'e0xjs10':
                    return {
                        resume: !1,
                        code: 'MIRA_1016',
                        text: J_string('remove table function error %s', [c[0]])
                    };
                    break;
                case 'e0xjs11':
                    return {
                        resume: !1,
                        code: 'MIRA_1017',
                        text: J_string('cannot read database (filesystem error) %s', [c[0]])
                    };
                    break;
                case 'e0xjs12':
                    return {
                        resume: !1,
                        code: 'MIRA_1018',
                        text: J_string('cannot remove database (filesystem error) %s', [c[0]])
                    };
                    break;
                case 'e0xjs13':
                    return {
                        resume: !1,
                        code: 'MIRA_1019',
                        text: J_string('duplicate database name %s are not allowed!', [c[0]])
                    };
                    break;
                case 'e0xjs14':
                    return {
                        resume: !1,
                        code: 'MIRA_1020',
                        text: J_string('cannot creat database (filesystem error) %s', [c[0]])
                    };
                    break;
                case 'e0xjs15':
                    return {
                        resume: !1,
                        code: 'MIRA_1021',
                        text: J_string('cannot build database (filesystem error) %s', [c[0]])
                    };
                    break;
                case 'e0xjs16':
                    return {
                        resume: !1,
                        code: 'MIRA_1022',
                        text: J_string('cannot creat table (filesystem error) %s', [c[0]])
                    };
                    break;
                case 'e0xjs17':
                    return {
                        resume: !1,
                        code: 'MIRA_1023',
                        text: J_string('cannot open table (critical error) %s', [c[0]])
                    };
                    break;
                case 'e0xjm01':
                    return {
                        resume: !1,
                        code: 'MIRA_6309',
                        text: J_string('string (%s) cannot be found in table', [c[0]])
                    };
                    break;
                case 'e0xjm02':
                    return {
                        resume: !1,
                        code: 'MIRA_6309',
                        text: J_string('column not found : (%s) ', [c[0]])
                    };
                    break;
                case 'e0xjm03':
                    return {
                        resume: !1,
                        code: 'MIRA_6209',
                        text: J_string('querystring : (%s) error ', [c[0]])
                    };
                    break;
                case 'e0xjm04':
                    return {
                        resume: !1,
                        code: 'MIRA_6309',
                        text: J_string('querystring : %s (VALUE) missing', [c[0]])
                    };
                    break;
                case 'e0xjm041':
                    return {
                        resume: !1,
                        code: 'MIRA_6309',
                        text: J_string('querystring : %s (INDEX) missing', [c[0]])
                    };
                    break;
                case 'e0xjm05':
                    return {
                        resume: !1,
                        code: 'MIRA_6308',
                        text: J_string('querystring : %s (COLUMN) missing', [c[0]])
                    };
                    break;
                case 'e0xjm06':
                    return {
                        resume: !1,
                        code: 'MIRA_6068',
                        text: J_string('querystring : table  %s  missing', [c[0]])
                    };
                    break;
                case 'e0xjm07':
                    return {
                        resume: !1,
                        code: 'MIRA_6068',
                        text: J_string('querystring : database  %s  missing', [c[0]])
                    };
            }
        } catch (d) {
            return {
                resume: !1,
                code: 'MIRA-0',
                text: '' + d
            }
        }
    }
};

function J_string(a, b) {
    return a.replace(/%s/g, function () {
        return b.shift()
    })
}

function ErrorMessages(a, b) {
    var c = a.toLowerCase(),
        d = c.match(/cannot|read|property|undefined/gi);
    if (-1 < d.indexOf('cannot') && -1 < d.indexOf('read') && -1 < d.indexOf('undefined')) return 'not exists ' + b
}